package com.iflytek.cloud.msc.util.http;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.InputStream;
import java.net.HttpURLConnection;
import java.net.MalformedURLException;
import java.net.URI;
import java.net.URISyntaxException;
import java.net.URL;
import java.util.Locale;

/*import org.apache.http.Header;
import org.apache.http.HttpHost;
import org.apache.http.HttpResponse;
import org.apache.http.HttpStatus;
import org.apache.http.auth.AuthScope;
import org.apache.http.auth.Credentials;
import org.apache.http.client.HttpClient;
import org.apache.http.client.methods.HttpGet;
import org.apache.http.client.methods.HttpPost;
import org.apache.http.client.methods.HttpRequestBase;
import org.apache.http.client.params.HttpClientParams;
import org.apache.http.conn.ClientConnectionManager;
import org.apache.http.conn.params.ConnRoutePNames;
import org.apache.http.conn.scheme.PlainSocketFactory;
import org.apache.http.conn.scheme.Scheme;
import org.apache.http.conn.scheme.SchemeRegistry;
import org.apache.http.conn.ssl.SSLSocketFactory;
import org.apache.http.entity.ByteArrayEntity;
import org.apache.http.entity.InputStreamEntity;
import org.apache.http.impl.client.DefaultHttpClient;
import org.apache.http.impl.conn.tsccm.ThreadSafeClientConnManager;
import org.apache.http.params.BasicHttpParams;
import org.apache.http.params.HttpConnectionParams;
import org.apache.http.params.HttpParams;
import org.apache.http.params.HttpProtocolParams;

import android.os.PowerManager;
import android.os.Process;

import com.iflytek.cloud.ErrorCode;
import com.iflytek.cloud.msc.util.log.DebugLog;*/

/**
 * network engine
 * 
 * @author kuncheng & bingchen 2011-6-20
 * @deprecated 弃用
 */
final class HttpClients extends Thread {/*

	static final String TAG = "HttpClients";

	private static final String DEFAULT_USER_AGENT = "Android/SpeechService";

	// private static final int MIN_RETRY_AFTER = 30; // 30s
	// private static final int MAX_RETRY_AFTER = 60 * 60; // 1h

	private static final int MAX_REDIRECT_COUNT = 20;
	private int mCurrrentRedirectCount;

	private static final int HTTP_GET = 1;
	private static final int HTTP_POST_STRING = 2;
	private static final int HTTP_POST_FILE = 3;

//	private Context mContext;
	private HttpTransListener mListener;
	private boolean mCancel;

	private String mUrl;
	private int mRequestType;
	private int mBufferSize;
	private int mRetryCount = 0;
	private int mRetryInterval = 1000;
	private int mCurrentRetryCount;
	private String mETag;

	private long mDownloadOffset;
	private byte[] mPostData;
	private File mPostFile;

	private HttpRequestBase mHttpRequest;
	private HttpClient mHttpClient;
	private HttpURLConnection httpURLConnection;

	private HttpHost mHttpHost;
	private Credentials mCredentials;

	public HttpClients(HttpTransListener listener) {
		mListener = listener;

		if (mListener == null) {
			throw new NullPointerException("the OnHttpTransListener object can not be null");
		}
	}

	*//**
	 * set the proxy, called before the network operating
	 *//*
	public void setProxy(HttpHost host) {
		mHttpHost = host;
	}

	*//**
	 * set the credentials, called before the network operating
	 *//*
	public void setCredentials(Credentials credentials) {
		mCredentials = credentials;
	}

	*//**
	 * 下载数据
	 * 
	 * @param url
	 * @param bufferSize
	 *//*
	public void get(String url, int bufferSize) {
		get(url, 0, null, bufferSize);
	}

	public void get(String url, long offset, String eTag, int bufferSize) {
		mRequestType = HTTP_GET;
		mUrl = url;
		mBufferSize = bufferSize;
		mDownloadOffset = offset;
		mCurrentRetryCount = 0;
		mCurrrentRedirectCount = 0;
		mETag = eTag;
		startRequest();
	}

	*//**
	 * 上传字符串
	 * 
	 * @param url
	 * @param data
	 * @param bufferSize
	 *//*
	public void post(String url, byte[] data, int bufferSize) {
		mRequestType = HTTP_POST_STRING;
		mUrl = url;
		mBufferSize = bufferSize;
		mPostData = data;
		mCurrentRetryCount = 0;
		mCurrrentRedirectCount = 0;
		startRequest();
	}

	*//**
	 * 上传文件
	 * 
	 * @param url
	 * @param file
	 * @param bufferSize
	 *//*
	public void post(String url, File file, int bufferSize, boolean gzipEncoding) {
		mRequestType = HTTP_POST_FILE;
		mUrl = url;
		mBufferSize = bufferSize;
		mPostFile = file;
		mCurrentRetryCount = 0;
		mCurrrentRedirectCount = 0;
		startRequest();
	}

	public void cancel() {
		mCancel = true;
		if (mHttpRequest != null && !mHttpRequest.isAborted()) {
			mHttpRequest.abort();
		}
	}

	private void startRequest() {
		if (!isAlive()) {
			start();
		}else {
			DebugLog.LogS("startRequest isAlive");
		}
	}

	private int createHttpClientInstance() {
		HttpParams params = new BasicHttpParams();

		HttpConnectionParams.setStaleCheckingEnabled(params, false);

		// 默认连接超时设置为20s
		HttpConnectionParams.setConnectionTimeout(params, 20 * 1000);
		HttpConnectionParams.setSoTimeout(params, 20 * 1000);
		HttpConnectionParams.setSocketBufferSize(params, 8192);

		// 自己处理重定向
		HttpClientParams.setRedirecting(params, false);

		HttpProtocolParams.setUserAgent(params, DEFAULT_USER_AGENT);
		SchemeRegistry schemeRegistry = new SchemeRegistry();
		schemeRegistry.register(new Scheme("http", PlainSocketFactory.getSocketFactory(), 80));
		schemeRegistry.register(new Scheme("https", SSLSocketFactory.getSocketFactory(), 443));

		ClientConnectionManager manager = new ThreadSafeClientConnManager(params, schemeRegistry);

		DefaultHttpClient httpClient = new DefaultHttpClient(manager, params);
		if (mHttpHost != null) {
			// 设置代理
			httpClient.getParams().setParameter(ConnRoutePNames.DEFAULT_PROXY, mHttpHost);
		}

		if (mCredentials != null) {
			// 设置用户名和密码
			httpClient.getCredentialsProvider().setCredentials(AuthScope.ANY, mCredentials);
		}

		mHttpClient = httpClient;
		return ErrorCode.SUCCESS;
	}


	private int createHttpRequestInstance() {
		if (mRequestType == HTTP_GET) {
			HttpGet httpRequest = new HttpGet(mUrl);
			// 如果不是分段请求，则不需要设置range属性，避免请求返回206
			if (mDownloadOffset > 0) {
				if (mETag != null) {
					httpRequest.addHeader("If-Match", mETag);
				}
				httpRequest.addHeader("Range", "bytes=" + mDownloadOffset + "-");
				DebugLog.LogS("HttpClient RANGE" + "bytes=" + mDownloadOffset);
			}
			
			mHttpRequest = httpRequest;
			return ErrorCode.SUCCESS;
		} else {
			HttpPost httpRequest = new HttpPost(mUrl);
//			if (mGzipEncoding) {
//				httpRequest.addHeader("Accept-Encoding", "gzip");
//			}
			try {
				if (mRequestType == HTTP_POST_STRING) {
					ByteArrayEntity byteArrayEntity = new ByteArrayEntity(mPostData);
					httpRequest.setEntity(byteArrayEntity);
				} else {
					InputStreamEntity reqEntity = new InputStreamEntity(new FileInputStream(mPostFile),
							mPostFile.length());
					reqEntity.setContentType("application/x-gzip");
					reqEntity.setChunked(false);
					httpRequest.setEntity(reqEntity);
				}
			} catch (FileNotFoundException e) {
				return ErrorCode.ERROR_FILE_ACCESS;
			}
			mHttpRequest = httpRequest;
			return ErrorCode.SUCCESS;
		}
	}

	*//**
	 * 取得文件类型
	 * 
	 * @param mimeType
	 * @return
	 *//*
	private String sanitizeMimeType(String mimeType) {
		try {
			mimeType = mimeType.trim().toLowerCase(Locale.ENGLISH);

			final int semicolonIndex = mimeType.indexOf(';');
			if (semicolonIndex != -1) {
				mimeType = mimeType.substring(0, semicolonIndex);
			}
			return mimeType;
		} catch (NullPointerException npe) {
			return null;
		}
	}

	*//**
	 * 是否允许重试
	 * 
	 * @return
	 *//*
	private boolean canRetry() {
		mCurrentRetryCount++;
		if (mCurrentRetryCount < mRetryCount) {
			try {
				sleep(mRetryInterval);
			} catch (InterruptedException e) {
				e.printStackTrace();
			}
			return true;
		} else {
			return false;
		}
	}

	// 如果cancel下载，处理流程上相当于发生了一种error，要abort下载，并且跳出循环
	@Override
	public void run() {
		Process.setThreadPriority(Process.THREAD_PRIORITY_BACKGROUND);
		PowerManager.WakeLock wakeLock = null;
		int finalErrorCode = ErrorCode.MSP_ERROR_FAIL;
//		String errorDetail = null;
		try {
			byte data[] = new byte[mBufferSize];
			long bytesSoFar = mDownloadOffset;

			int errorCode;
			if ((errorCode = createHttpClientInstance()) != ErrorCode.SUCCESS) {
				finalErrorCode = errorCode;
				return;
			}
			if ((errorCode = createHttpRequestInstance()) != ErrorCode.SUCCESS) {
				finalErrorCode = errorCode;
				return;
			}
			http_request_loop: while (!mCancel) {
				HttpResponse response;
				try {
					// 执行网络请求
					response = mHttpClient.execute(mHttpRequest);
				} catch (Exception ex) {
					finalErrorCode = ErrorCode.ERROR_NET_EXCEPTION;
					mHttpRequest.abort();
					if (canRetry()) {
						continue;
					} else {
						break;
					}
				}

				if (mCancel) {
					mHttpRequest.abort();
					break;
				}
				boolean continuingDownload = mDownloadOffset > 0;
				int statusCode = response.getStatusLine().getStatusCode();
				if (statusCode == 301 || statusCode == 302 || statusCode == 303 || statusCode == 307) {
					mCurrrentRedirectCount++;
					if (mCurrrentRedirectCount > MAX_REDIRECT_COUNT) {
						mHttpRequest.abort();
						finalErrorCode = ErrorCode.ERROR_NET_EXCEPTION;
						DebugLog.LogS("request redirection overflow");
						break;
					}
					// 处理重定向，定位新的Url
					Header header = response.getFirstHeader("Location");
					if (header != null) {
						try {
							mUrl = new URI(mUrl).resolve(new URI(header.getValue())).toString();
						} catch (URISyntaxException ex) {
							mHttpRequest.abort();
							finalErrorCode = ErrorCode.ERROR_INVALID_RESULT;
							break;
						}
						mHttpRequest.abort();
						if ((errorCode = createHttpRequestInstance()) != ErrorCode.SUCCESS) {
							finalErrorCode = errorCode;
							break;
						} else {
							continue;
						}
					} else {
						mHttpRequest.abort();
						finalErrorCode = ErrorCode.ERROR_INVALID_RESULT;
						break;
					}
				}

				if ((!continuingDownload && statusCode != HttpStatus.SC_OK)
						|| (continuingDownload && statusCode != HttpStatus.SC_PARTIAL_CONTENT)) {
					finalErrorCode = ErrorCode.MSP_ERROR_HTTP_BASE + statusCode;
					mHttpRequest.abort();
					if (canRetry()) {
						continue;
					} else {
						break;
					}
				}

				String headerContentDisposition = null;
				String headerContentLength = null;
				String headerContentLocation = null;
				String headerETag = null;

				Header header = response.getFirstHeader("Content-Disposition");
				if (header != null) {
					headerContentDisposition = header.getValue();
				}
				header = response.getFirstHeader("Content-Location");
				if (header != null) {
					headerContentLocation = header.getValue();
				}

				String mimeType = null;
				header = response.getFirstHeader("Content-Type");
				if (header != null) {
					// 获取文件类型
					mimeType = sanitizeMimeType(header.getValue());
					DebugLog.LogS("Http Response Content-Type:" + mimeType);
				}

				header = response.getFirstHeader("Content-Length");
				if (header != null) {
					headerContentLength = header.getValue();
				}

				header = response.getFirstHeader("ETag");
				if (header != null) {
					headerETag = header.getValue();
				}
				
				

				long contentLength = 0;
				if (headerContentLength != null) {
					contentLength = Long.parseLong(headerContentLength);
				}

				if (bytesSoFar > 0) {
					contentLength += bytesSoFar;
				}

				if (contentLength <= 0) {
					finalErrorCode = ErrorCode.ERROR_INVALID_RESULT;
					mHttpRequest.abort();
					break;
				} else {
					// 发送开始事件
					if (!mCancel) {
						int rst = mListener.onStart(contentLength, mimeType, mUrl, headerETag,
								headerContentDisposition, headerContentLocation);
						if (mCancel) {
							mHttpRequest.abort();
							break;
						}
						if (rst != 0) {
							finalErrorCode = rst;
							mHttpRequest.abort();
							break;
						}
					} else {
						mHttpRequest.abort();
						break;
					}

					InputStream entityStream = null;
					try {
						entityStream = response.getEntity().getContent();
						if (mCancel) {
							mHttpRequest.abort();
							break;
						}
						for (;;) {
							int bytesRead;
							// 读取数据
							bytesRead = entityStream.read(data);
							// 读取数据操作耗时，所以再检查下是否取消
							if (mCancel) {
								mHttpRequest.abort();
								break http_request_loop;
							}
							if (bytesRead == -1) {
								// success
								if (bytesSoFar != contentLength) {
									finalErrorCode = ErrorCode.ERROR_INVALID_RESULT;
//									errorDetail = "http content length and downloaded length is not valid";
									mHttpRequest.abort();
									break http_request_loop;
								} else {
									// 读取字节数和总长度一致，则下数据传输完成
									finalErrorCode = ErrorCode.SUCCESS;
									break http_request_loop;
								}
							} else {
								errorCode = mListener.onBuffer(data, bytesRead);
								if (errorCode == 0) {
									bytesSoFar += bytesRead;
									if (mCancel) {
										mHttpRequest.abort();
										break http_request_loop;
									}
								} else {
									if (!mCancel) {
										finalErrorCode = errorCode;
									}
									mHttpRequest.abort();
									break http_request_loop;
								}
							}
						}
					} catch (IOException ex) {
						finalErrorCode = ErrorCode.ERROR_NET_EXCEPTION;
						mHttpRequest.abort();
						if (canRetry()) {
							continue;
						} else {
							break;
						}
					} finally {
						// 需要关闭输入流，参考了http://hc.apache.org/httpcomponents-client-ga/httpclient/examples/org/apache/http/examples/client/ClientConnectionRelease.java
						try {
							if (entityStream != null) {
								entityStream.close();
								entityStream = null;
							}
						} catch (IOException ignore) {
						}
					}

				}
				// break;
			}
		} finally {
			DebugLog.LogS(TAG, "finally | mCancel = " + mCancel + " code=" +finalErrorCode);
			if (wakeLock != null) {
				wakeLock.release();
				wakeLock = null;
			}
			if (mHttpClient != null) {
				mHttpClient.getConnectionManager().shutdown();
				mHttpClient = null;
			}
			try{
    			if (mCancel) {
    				mListener.onCancel();
    			} else {
    				if (finalErrorCode == ErrorCode.SUCCESS) {
    					mListener.onFinish();
    				} else {
    					mListener.onError(finalErrorCode);
    				}
    			}
			} catch (Exception listener_e) {
			    listener_e.printStackTrace();
			}
		}
	}*/
}
